/*
 * LICENCE[[
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1/CeCILL 2.O
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is kelis.fr code.
 *
 * The Initial Developer of the Original Code is
 * sylvain.spinelli@kelis.fr
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * or the CeCILL Licence Version 2.0 (http://www.cecill.info/licences.en.html),
 * in which case the provisions of the GPL, the LGPL or the CeCILL are applicable
 * instead of those above. If you wish to allow use of your version of this file
 * only under the terms of either the GPL, the LGPL or the CeCILL, and not to allow
 * others to use your version of this file under the terms of the MPL, indicate
 * your decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL, the LGPL or the CeCILL. If you do not
 * delete the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL, the LGPL or the CeCILL.
 * ]]LICENCE
 */
 
function irAudioPlayer() {
}

irAudioPlayer.prototype = {
	fCurrentAudio : null,
	fCounter : 0,
	playAudio : function (pAudio, pStartPlayIdx, pStopPlayIdx, pRate, pCb, pStepCallback) {
		
		//On bascule sur ce nouvel audio.
		var vNewId = this.xSwitchAudio(pAudio);		
		
		//On prpare le wrapper
		var vCbWrapper = {
			fCb : pCb,
			fService : this,
			fId : vNewId,
			onError : function () {
				if(this.fCb) try{this.fCb.onError();}catch(e){}
				this.fService.xAudioClosed(this.fId);
			},
			onStop : function () {
				if(this.fCb) try{this.fCb.onStop();}catch(e){}
				this.fService.xAudioClosed(this.fId);
			},
			get smpRead() {return this.fCb.smpRead},
			set smpRead(pValue) {this.fCb.smpRead = pValue; return pValue;},
			
			QueryInterface : function (iid) {
		        if (iid.equals(Components.interfaces.irIPlayerCallback) ||
		            iid.equals(Components.interfaces.nsISupports))
		            return this;
		        Components.returnCode = Components.results.NS_ERROR_NO_INTERFACE;
		        return null;
		    }
		}
		pAudio.playAudio(pStartPlayIdx, pStopPlayIdx, pRate, vCbWrapper, pStepCallback);
	},
	
	/* Interne. NOTE : devrait etre synchronise avec this.xSwitchAudio(). */
	xAudioClosed : function (pId) {
		if(this.fCounter === pId) this.fCurrentAudio = null;
	},
	
	/* Interne. NOTE : devrait etre synchronise avec this.xAudioClosed(). */
	xSwitchAudio : function (pAudio) {
		if(this.fCurrentAudio) try{this.fCurrentAudio.stopAudio();}catch(e){}
		this.fCurrentAudio = pAudio;
		this.fCounter = this.fCounter + 1;
		return this.fCounter;
	},

    // nsISupports interface
    QueryInterface : function (iid) {
        if (iid.equals(Components.interfaces.irIAudioPlayer) ||
            iid.equals(Components.interfaces.nsISupports))
            return this;
        Components.returnCode = Components.results.NS_ERROR_NO_INTERFACE;
        return null;
    },

    // This Component's module implementation.  All the code below is used to get this
    // component registered and accessible via XPCOM.
    module : {
        // registerSelf: Register this component.
        registerSelf : function (compMgr, fileSpec, location, type) {
            var compReg = compMgr.QueryInterface( Components.interfaces.nsIComponentRegistrar );
            compReg.registerFactoryLocation( this.cid,
                                             "Audio Player Service",
                                             this.contractId,
                                             fileSpec,
                                             location,
                                             type );
        },

        // getClassObject: Return this component's factory object.
        getClassObject : function (compMgr, cid, iid) {
            if (!cid.equals(this.cid))
                throw Components.results.NS_ERROR_NO_INTERFACE;

            if (!iid.equals(Components.interfaces.nsIFactory))
                throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

            return this.factory;
        },

        /* CID for this class */
        cid : Components.ID("{D9CCF4BE-0902-4684-AFF5-83E0DF359BDF}"),

        /* Contract ID for this class */
        contractId : "@kelis.fr/audioPlayerService",

        /* factory object */
        factory : {
            // createInstance: Return a new irAudioPlayer object.
            createInstance: function (outer, iid) {
                if (outer != null)
                    throw Components.results.NS_ERROR_NO_AGGREGATION;

                return (new irAudioPlayer()).QueryInterface(iid);
            }
        },

        // canUnload: n/a (returns true)
        canUnload : function(compMgr) {
            return true;
        }
    }
}


	
function debug(pText){
	var vConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	vConsoleService.logStringMessage(pText);
}

// NSGetModule: Return the nsIModule object.
function NSGetModule(compMgr, fileSpec) {
    return irAudioPlayer.prototype.module;
}
